# OpenStreetMap Carto DE setup instructions

The database scheme we use in german manik style does not use use separate
database columns for different tags. Instead only one hstore column is used
to provide all important tags (see hstore-only.style osm2pgsql style).

For this reason the osm2pgsql commandline required will look slightly different:

```
osm2pgsql -G -S hstore-only.style --hstore --tag-transform-script openstreetmap-carto.lua planet-latest.osm.pbf -p planet_osm_hstore
```

The database layout of the git master branch is aiming to be compatible witch
openstreetmap-carto 4.x

For older databases without lua transform script use the de3.x branch.

You also need to make sure that the version of osm2pgsql used supports the `nocolumn` option!
This is the case from 0.89 onwards. 

The actual rendering is done using database views providing virtual columns
instead of using the raw tables generated by osm2pgsql. These views have to
be created after the initial osm2pgsql data import using the provided SQL
files as follows:

```
psql -d osm -f osm_tag2num.sql
psql -d osm -f views_osmde/view-line.sql
psql -d osm -f views_osmde/view-point.sql
psql -d osm -f views_osmde/view-polygon.sql
psql -d osm -f views_osmde/view-roads.sql
```

For compatibility reasons, the views are given the same name as the default
osm2pgsql tables used in upstream openstreetmap carto style.

The style is currently developed using Debian GNU/Linux 8.x with a few
additional [backports](https://tile.openstreetmap.de/debian8-backports/)
in cases where the required software is not available in plain Debian 8.
Due to an incompatible change in PostGIS we will also need PostGIS >= 2.2
which is available as a backport for Debian 8.  Currently it will however
also work to undo commit 4f88f1f24c4288e957e74d0cc5ec4051d7a2273a to
recover compatibility with PostGIS 2.1.

To get this style running it is also required to add the
[l10n code](https://github.com/giggls/mapnik-german-l10n)
to the postgresql database.

If l10n is not needed it is also possible to slightly modify either
project.yaml or the database views provided in the `views_osmde` directory.

To actually use this style you need to generate ```osm-de.xml``` from ```project.mml```.
The easiest way to do this is using ```make```!

It is also possible to use [Magnacarto](https://github.com/omniscale/magnacarto) or
[Kosmtik](https://github.com/kosmtik/kosmtik).
Both projects can use ```project.mml``` directly.
